
{-# LANGUAGE NoImplicitPrelude       #-}

module Spec where

import Data.Set as Set
import Data.String.Conversions (cs)
import Data.Text (Text)
import qualified Eigen.Matrix as Matrix
import Graph.BAC.ProxemyOptim
import Graph.FGL
import Prelude (String)
import Protolude
import Graph.BAC.ProxemyOptim
import qualified Data.IntMap                       as Dict
import qualified Eigen.SparseMatrix as SMatrix
import qualified Prelude as Prelude
import qualified Data.List as List


main :: IO ()
main = do
  let 

      edges_test :: [(Int,Int)]
      edges_test=[(0,1),(0,2),(0,4),(0,5),(0,3),(0,6)
                 ,(1,2),(1,3),(2,3),(4,5),(4,6),(5,6)
                 ,(7,8),(7,3),(7,4),(8,2),(8,5)
                 ]

      clustering_result =
        ClusteringIs { parts = Dict.fromList [(0, Set.fromList [0,4,5,6])
                                             ,(1, Set.fromList [1,2,3])
                                             ,(7, Set.fromList [7,8])]
                     , index = Dict.fromList [(0,0),(1,1),(2,1)
                                             ,(3,1),(4,0),(5,0)
                                             ,(6,0),(7,7),(8,7)
                                             ]
                     , score = 3.0558391780792453
                     , mode = Part
                     }

      g :: Graph () ()
      g = mkGraphUfromEdges edges_test

      result = withG g (identity  . (clusteringOptim 3 Conf))

  print $ result == clustering_result

test_random :: IO ()
test_random = do
  m <- randomAdjacency
  let
    g :: Graph () ()
    g = mkGraphUfromEdges
      $ List.map (\(x,y,_) -> (x,y))
      $ SMatrix.toList m
    result = withG g (identity  . (clusteringOptim 3 Conf))
  print (result)
